=== PKGBUILD ===
# Maintainer: Christoph Reiter <reiter.christoph@gmail.com>

_realname=whisper.cpp
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.5.4
pkgrel=1
pkgdesc="Port of OpenAI's Whisper model in C/C++ (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64' 'mingw64')
url='https://github.com/ggerganov/whisper.cpp'
license=('spdx:MIT')
depends=(
  "${MINGW_PACKAGE_PREFIX}-openblas"
  "${MINGW_PACKAGE_PREFIX}-SDL2"
  "${MINGW_PACKAGE_PREFIX}-gcc-libs"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-pkgconf"
)
source=("https://github.com/ggerganov/whisper.cpp/archive/refs/tags/v${pkgver}.tar.gz"
        "0001-fix-importlib-location.patch"
        "0002-fix-openblas-lookup.patch"
        "0004-download-models-pwd.patch")
sha256sums=('06eed84de310fdf5408527e41e863ac3b80b8603576ba0521177464b1b341a3a'
            '30765001468dbc40893a2a63e675b2b40f290e27c3314e82dd7f72404d2d1ccf'
            '0314546c2ab5810ba84d4b2e14a84f992a282fc57698bd7a678756f8f6d13171'
            '1089b4e4a519d908551707bdaf5e9a917ecf8d7702b2c405677cc22b7a2fda0f')
noextract=("v${pkgver}.tar.gz")

prepare() {
  tar xzf "v${pkgver}.tar.gz" || tar xzf "v${pkgver}.tar.gz"
  cd "${srcdir}"/${_realname}-${pkgver}

  patch -p1 -i "${srcdir}/0001-fix-importlib-location.patch"
  patch -p1 -i "${srcdir}/0002-fix-openblas-lookup.patch"

  # So that "whisper.cpp-download-ggml-model.sh base.en"
  # is all that's needed to get started
  patch -p1 -i "${srcdir}/0004-download-models-pwd.patch"
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  CFLAGS+=" $(pkgconf.exe --cflags openblas)" \
  LDFLAGS+=" -Wl,--export-all-symbols" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DWHISPER_SDL2=ON \
      -DWHISPER_OPENBLAS=ON \
      -DWHISPER_BUILD_EXAMPLES=ON \
      -DBLAS_LIBRARIES="`pkgconf --libs-only-l openblas`" \
      -DBLAS_INCLUDE_DIRS="`pkgconf --cflags-only-I openblas`" \
      -DBUILD_SHARED_LIBS=ON \
      -DWHISPER_ALL_WARNINGS=OFF \
      "${extra_config[@]}" \
      ../${_realname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  # Install the examples by prefixing them with whisper.cpp
  # except main.exe, which gets installed as plain whisper.cpp.exe
  for i in bin/*.exe; do
    install -Dm755 "${i}" \
      "${pkgdir}${MINGW_PREFIX}/bin/${_realname}-${i//bin\//}"
  done
  mv "${pkgdir}${MINGW_PREFIX}/bin/${_realname}-main.exe" \
    "${pkgdir}${MINGW_PREFIX}/bin/${_realname}.exe"

   install -Dm755 "${srcdir}/${_realname}-${pkgver}/models/download-ggml-model.sh" \
     "${pkgdir}${MINGW_PREFIX}/bin/${_realname}-download-ggml-model.sh"

  # Avoid conflicts with llama.cpp:
  # https://github.com/ggerganov/whisper.cpp/pull/1568#issuecomment-1835804359
  mv "${pkgdir}${MINGW_PREFIX}/include/ggml.h" "${pkgdir}${MINGW_PREFIX}/include/whisper-ggml.h"
  sed -i 's/ggml\.h/whisper-ggml.h/g' "${pkgdir}${MINGW_PREFIX}/include/whisper.h"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
